/* barChartSample.c was originally generated by the autoSql program, which also 
 * generated barChartSample.h and barChartSample.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "barChartSample.h"



char *barChartSampleCommaSepFieldNames = "sample,category";

void barChartSampleStaticLoad(char **row, struct barChartSample *ret)
/* Load a row from barChartSample table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->sample = row[0];
ret->category = row[1];
}

struct barChartSample *barChartSampleLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all barChartSample from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with barChartSampleFreeList(). */
{
struct barChartSample *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = barChartSampleLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void barChartSampleSaveToDb(struct sqlConnection *conn, struct barChartSample *el, char *tableName, int updateSize)
/* Save barChartSample as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. This function automatically escapes quoted strings for mysql. */
{
struct dyString *update = dyStringNew(updateSize);
sqlDyStringPrintf(update, "insert into %s values ( '%s','%s')", 
	tableName,  el->sample,  el->category);
sqlUpdate(conn, update->string);
dyStringFree(&update);
}

struct barChartSample *barChartSampleLoad(char **row)
/* Load a barChartSample from row fetched with select * from barChartSample
 * from database.  Dispose of this with barChartSampleFree(). */
{
struct barChartSample *ret;

AllocVar(ret);
ret->sample = cloneString(row[0]);
ret->category = cloneString(row[1]);
return ret;
}

struct barChartSample *barChartSampleLoadAll(char *fileName) 
/* Load all barChartSample from a whitespace-separated file.
 * Dispose of this with barChartSampleFreeList(). */
{
struct barChartSample *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileRow(lf, row))
    {
    el = barChartSampleLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct barChartSample *barChartSampleLoadAllByChar(char *fileName, char chopper) 
/* Load all barChartSample from a chopper separated file.
 * Dispose of this with barChartSampleFreeList(). */
{
struct barChartSample *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[2];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = barChartSampleLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct barChartSample *barChartSampleCommaIn(char **pS, struct barChartSample *ret)
/* Create a barChartSample out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new barChartSample */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->sample = sqlStringComma(&s);
ret->category = sqlStringComma(&s);
*pS = s;
return ret;
}

void barChartSampleFree(struct barChartSample **pEl)
/* Free a single dynamically allocated barChartSample such as created
 * with barChartSampleLoad(). */
{
struct barChartSample *el;

if ((el = *pEl) == NULL) return;
freeMem(el->sample);
freeMem(el->category);
freez(pEl);
}

void barChartSampleFreeList(struct barChartSample **pList)
/* Free a list of dynamically allocated barChartSample's */
{
struct barChartSample *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    barChartSampleFree(&el);
    }
*pList = NULL;
}

void barChartSampleOutput(struct barChartSample *el, FILE *f, char sep, char lastSep) 
/* Print out barChartSample.  Separate fields with sep. Follow last field with lastSep. */
{
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->sample);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->category);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

